## API Report File for "@microsoft/fast-element"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @public
export type Context<T> = {
    readonly name: string;
    readonly initialValue?: T;
};

// @public
export const Context: Readonly<{
    eventType: "context-request";
    for<T = unknown>(name: string): FASTContext<T>;
    create<T_1 = unknown>(name: string, initialValue?: T_1 | undefined): FASTContext<T_1>;
    setDefaultRequestStrategy(strategy: FASTContextRequestStrategy): void;
    get<T_2 extends UnknownContext>(target: EventTarget, context: T_2): ContextType<T_2>;
    request<T_3 extends UnknownContext>(target: EventTarget, context: T_3, callback: ContextCallback<ContextType<T_3>>, multiple?: boolean): void;
    dispatch<T_4 extends UnknownContext>(target: EventTarget, context: T_4, callback: ContextCallback<ContextType<T_4>>, multiple?: boolean): void;
    provide<T_5 extends UnknownContext>(target: EventTarget, context: T_5, value: ContextType<T_5>): void;
    handle<T_6 extends UnknownContext>(target: EventTarget, callback: (event: ContextEvent<T_6>) => void, context?: T_6 | undefined): void;
    defineProperty<T_7 extends UnknownContext>(target: Constructable<EventTarget> | EventTarget, propertyName: string, context: T_7): void;
}>;

// @public
export type ContextCallback<ValueType> = (value: ValueType, dispose?: () => void) => void;

// Warning: (ae-forgotten-export) The symbol "ParameterDecorator_2" needs to be exported by the entry point context.d.ts
//
// @public
export type ContextDecorator<T = any> = Readonly<Context<T>> & PropertyDecorator & ParameterDecorator_2;

// @public
export class ContextEvent<T extends UnknownContext> extends Event {
    constructor(context: T, callback: ContextCallback<ContextType<T>>, multiple?: boolean | undefined);
    // (undocumented)
    readonly callback: ContextCallback<ContextType<T>>;
    // (undocumented)
    readonly context: T;
    // (undocumented)
    readonly multiple?: boolean | undefined;
}

// @public
export type ContextType<T extends UnknownContext> = T extends Context<infer Y> ? Y : never;

// @public
export type FASTContext<T> = ContextDecorator<T> & {
    get(target: EventTarget): T;
    provide(target: EventTarget, value: T): void;
    request(target: EventTarget, callback: ContextCallback<T>, multiple?: boolean): void;
    handle(target: EventTarget, callback: (event: ContextEvent<FASTContext<T>>) => void): void;
};

// @public
export type FASTContextRequestStrategy = <T extends UnknownContext>(target: EventTarget, context: T, callback: ContextCallback<ContextType<T>>, multiple: any) => void;

// @public
export type UnknownContext = Context<unknown>;

// Warnings were encountered during analysis:
//
// dist/dts/context.d.ts:127:5 - (ae-forgotten-export) The symbol "Constructable" needs to be exported by the entry point context.d.ts

// (No @packageDocumentation comment for this package)

```
